<template>
  <div v-if="database.length">
    <div style="padding-left: 120px">
      <p style="font-size: 36px" class=" mb-4 opacity-60 pl-4">Ряд №</p>
      <div style="height: 2px;width: 131px;background-color: #673AB7"></div>
    </div>
    <div class="flex relative mb-16" style="padding-left: 100px">
      <div class="absolute opacity-60" style="font-size: 34px; width: 29px; height: 51px; top: -20px;left: 40px">0</div>
      <div class="absolute opacity-60" style="font-size: 34px; width: 29px; height: 51px; top: -20px;right: 80px">26</div>
      <div class="w-16 border-r-2 border-l-2 mb-6 num-wrap mt-12 flex flex-col items-center text-center">
        <div
          v-for="index in database.length - 2"
          v-show="index !== 74"
          style="font-size: 34px; width: 29px; height: 51px;"
          class="opacity-60"
        >{{ index }}</div>
      </div>
      <div class="mt-12 ml-4 w-full grid grid-cols-3 gap-x-12" style="margin-right: 200px">
        <div>
          <div
            v-for="(n, index) in database"
            :key="`kazan4.stage-${index + Math.random()}`"
            v-show="index !== 0 && index !== 26"
            class="line-wrap relative"
          >
            <div
              :class="{
                'red': n.perc_fill_mezo_volume > 75,
                'yellow': n.perc_fill_mezo_volume <= 75 && n.perc_fill_mezo_volume > 50,
                'green': n.perc_fill_mezo_volume <= 50,
                'opacity-0': index === 1,
              }"
              class="line"
            ></div>
            <div
              :class="{
                'red': n.perc_fill_mezo_volume > 75,
                'yellow': n.perc_fill_mezo_volume <= 75 && n.perc_fill_mezo_volume > 50,
                'green': n.perc_fill_mezo_volume <= 50,
                'opacity-0': index === 25,
              }"
              class="line-1"
            ></div>
            <div v-if="index === 24" class="ladder gray" :style="{
            top: '-11px',
            left: index === 24 ? '50px' : false
          }"></div>
          </div>
        </div>
        <div>
          <div
            v-for="(n, index) in database"
            :key="`kazan4.story_1${index + Math.random()}`"
            v-show="index !== 0 && index !== 26"
            class="line-wrap relative"
          >
            <div
              :class="{
                'red': n.perc_fill_mezo_volume > 75,
                'yellow': n.perc_fill_mezo_volume <= 75 && n.perc_fill_mezo_volume > 50,
                'green': n.perc_fill_mezo_volume <= 50,
                'opacity-0': index === 1,
              }"
              class="line"
            ></div>
            <div
              :class="{
                'red': n.perc_fill_mezo_volume > 75,
                'yellow': n.perc_fill_mezo_volume <= 75 && n.perc_fill_mezo_volume > 50,
                'green': n.perc_fill_mezo_volume <= 50,
                'opacity-0': index === 25,
              }"
              class="line-1"
            ></div>
            <div v-if="index === 8||index === 24||index === 24" class="ladder gray top-0" :style="{
            top: '-11px',
            left: index === 8 ? '0px' : index === 24 ? '0px' : false
          }"></div>
            <div v-if="index === 8||index === 24||index === 24" class="ladder gray top-0" :style="{
            top: '-11px',
            left: index === 8 ? '1073px' : index === 24 ? '1073px' : false
          }"></div>
          </div>
        </div>
        <div>
          <div
            v-for="(n, index) in database"
            :key="`kazan4.story_1${index + Math.random()}`"
            v-show="index !== 0 && index !== 26"
            class="line-wrap relative"
          >
            <div
              :class="{
                'red': n.perc_fill_mezo_volume > 75,
                'yellow': n.perc_fill_mezo_volume <= 75 && n.perc_fill_mezo_volume > 50,
                'green': n.perc_fill_mezo_volume <= 50,
                'opacity-0': index === 1,
              }"
              class="line"
            ></div>
            <div
              :class="{
                'red': n.perc_fill_mezo_volume > 75,
                'yellow': n.perc_fill_mezo_volume <= 75 && n.perc_fill_mezo_volume > 50,
                'green': n.perc_fill_mezo_volume <= 50,
                'opacity-0': index === 25,
              }"
              class="line-1"
            ></div>

            <div v-if="index === 24" class="ladder gray top-0" :style="{
            top: '-11px',
            left: index === 24 ? '1023px' : false
          }"></div>
          </div>
        </div>
      </div>
      <div :class="{
      'red': database[1].perc_fill_mezo_volume > 75,
              'yellow': database[1].perc_fill_mezo_volume <= 75 && database[1].perc_fill_mezo_volume > 50,
              'green': database[1].perc_fill_mezo_volume <= 50,
    }" class="absolute left-0 horizontal-line" style="width: calc(100% - 240px); z-index: 2"></div>
      <div :class="{
      'red': database[25].perc_fill_mezo_volume > 75,
              'yellow': database[25].perc_fill_mezo_volume <= 75 && database[25].perc_fill_mezo_volume > 50,
              'green': database[25].perc_fill_mezo_volume <= 50,
      }" class="absolute w-full left-0 horizontal-line" style="bottom: -30px;width: calc(100% - 300px)"></div>
      <div :class="{
      'red': database[0].perc_fill_mezo_volume > 75,
              'yellow': database[0].perc_fill_mezo_volume <= 75 && database[0].perc_fill_mezo_volume > 50,
              'green': database[0].perc_fill_mezo_volume <= 50,
    }" class="absolute h-full left-0 vertical-line" style="height: calc(100% - 40px)"></div>
      <div :class="{
      'red': database[26].perc_fill_mezo_volume > 75,
              'yellow': database[26].perc_fill_mezo_volume <= 75 && database[26].perc_fill_mezo_volume > 50,
              'green': database[26].perc_fill_mezo_volume <= 50,
      }" class="absolute h-full right-0 vertical-line" style="height: calc(100% - 40px)"></div>
      <div class="absolute down-block w-8 h-12" style="left: 1308px;bottom: 0; outline: 12px solid white"></div>
      <div class="absolute down-block w-8 h-12" style="right: 1330px;bottom: 0; outline: 12px solid white"></div>
    </div>
    <div style="padding-left: 90px" class="flex">
      <div class="flex items-center mr-16"><span class="w-20 h-20 mr-4 green inline-flex rounded"></span><span class="text-5xl opacity-70">Мест много</span></div>
      <div class="flex items-center mr-16"><span class="w-20 h-20 mr-4 yellow inline-flex rounded"></span><span class="text-5xl opacity-70">Мест ограничено</span></div>
      <div class="flex items-center mr-16"><span class="w-20 h-20 mr-4 red inline-flex rounded"></span><span class="text-5xl opacity-70">Раскладка запрещена</span></div>
      <div v-if="isSafe && stage !== '2'" class="flex items-center mr-16"><span class="w-20 h-20 mr-4 pink inline-flex rounded"></span><span class="text-5xl opacity-70">Сейф</span></div>
      <div class="flex items-center mr-16"><span class="w-20 h-20 mr-4 gray inline-flex rounded"></span><span class="text-5xl opacity-70">Лестница</span></div>
      <div class="flex items-center mr-16"><span class="w-20 h-20 mr-4 down-block inline-flex rounded"></span><span class="text-5xl opacity-70">Спуск</span></div>
    </div>
  </div>
</template>

<script>
import {computed, onMounted, ref} from "vue";
import address from "../API/address";

export default {
  name: "Store2",
  props: {
    isSafe: {type: Boolean, default: false},
    store: {type: String, default: false},
    stage: {type: String, default: false},
  },
  setup(props) {
    const database = ref([])
    async function getDatabase () {
      await address().get('data.json')
        .then(r => {
          database.value = r.data
          init()
        })
    }

    onMounted(async () => {
      await getDatabase()
      setInterval(async () => {
        await getDatabase()
      } ,1200000)
    })

    function init () {
      if(props.store === '4') {
        if (props.stage === '2') database.value = database.value.kazan4_food[props.stage][0]
        else database.value = database.value.kazan4[props.stage][0]
      }
      database.value.length && (database.value = database.value.sort((a, b) => a.street - b.street))
    }
    const getReversedIndexes = computed(() => {
      const length = database.value.length - 2
      return Array.from({ length }, (_, i) => length - i);
    })
    return {
      database,
      getReversedIndexes
    }
  },
}
</script>

<style lang="scss" scoped>
.green {background-color: #219653}
.yellow {background-color: #F2C94C}
.pink {background-color: #FCDDEC!important;}
.red {background-color: #EB5757}
.gray {background-color: #333333}

.down-block {
  background: linear-gradient(to bottom right, #FF7800 50%, #333333 50%);
}

.ladder {
  position: absolute;
  display: flex;
  align-items: center;
  justify-content: center;
  width: 50px;
  height: 20px;
  background-color: #333333;
  outline: 2px solid white;
  &::before {
    content: '';
    width: 100%;
    height: 2px;
    background-color: white;
  }
}

.line-wrap {
  .line, .line-1 {
    height: 10px;
    border-radius: 5px;
  }
  .line {
    margin-bottom: 29px;
  }
  .line-1 {
    margin-bottom: 2px;
  }
}

.horizontal-line {
  height: 10px;
  border-radius: 4px;
  margin: 29px 150px 30px 91px;
}
.vertical-line {
  width: 10px;
  border-radius: 4px;
  margin: 29px 150px 30px 91px;
}
.solo-line-top, .solo-line-bot {
  height: calc(100% + 40px);
  //transform: translate(0, -40px);
}
.solo-line-bot {
  transform: translate(0, -40px);
}
</style>
